//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,C,c,z0,D, zNeuN,zAltN,zaehler,nenner;
  ArrayList<Complex> Fixpunkte;
  int AnzahlFixpunkte;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int tN;
  int selektor;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  int zaehlen;
  double b; //Imaginärteil der iterierten komplexen Zahl zNeu
  int farbIndex =0;
  double laenge,abstand,winkelAbstand;
  double x0 ;
  double y0 ;
  double r,R,rM;
  boolean trapped;
  double mR,mI;
  Complex [] MP;
  int j;
  double epsilon ;
  float fxMin, fxMax, fyMin, fyMax;
  String s;
  double gW = 60;
  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, 
                 int nummer, double X0, double Y0, int Selektor, double e) {
    // benötigte Parameter
    epsilon =e;
    selektor = Selektor;
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    x0 = X0; y0 = Y0;
   
    maxiterations = pmaxiterations; //Anzahl der Iterationschritte für das Konvergenz-Geschwindigkeitsbild
    massFuerUnendlich = pmUnendlich; 
    
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
    zaehlen =0;
    int[][] Rand = new int[width][height/anzahlThreads];
    for (int j =0; j < height/anzahlThreads; j++) {  
      for (int i = 0; i < width; i++) {
         Rand[i][j]=0;
      }
    }
    r=0.23;//Radius der 8 Kreise außen
    rM = 0.25;//Radius des Kreises bei Null
    R=r/Math.sin(Math.PI/8);
    MP = new Complex [8];
    for (int i =0; i<8; i++){
      mR = R*Math.cos(i*Math.PI/4);
      mI = R*Math.sin(i*Math.PI/4);
      MP[i] = new Complex(mR,mI);//if (tN ==8)println(MP[i]);
    }
  }
////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   
    return tN;   
  }

 //////////////////////////////////////////////////////////////
public void run() {
    
  switch(selektor){
    case 1: 
      bild1();
      break;
  
    case 2:
      bild2();
      break;
      
    case 3:
      bild3();
      break;
      
    case 4:
      bild4();
      break;
      
    
  }
   
}
///////////////////////////////////////////////////////////////////
color julia(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    //float W = (float)Z0.getAngle();
    trapped = false;
    zAlt = Z0;
    //if(tN==8)println(zAlt);
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = JuliaIteration(zAlt); 
      if(Math.abs(zNeu.getImaginaryPart())>380) break; //damit kein NaN-Fehler entsteht
     
      zAlt = zNeu;
      n++;
    }
 //end of while---------------------------------------------------------------------  
   
   if(n<maxiterations){
     rueckgabe = color(0);
   }else{
    float H = abs(100*(float)zNeu.getAngle());     
    farbIndex = round(H) % 8192; 
    rueckgabe = farben.farben8192Bonbon[farbIndex];
    // rueckgabe = color(255); //für schwarz-weiß Bild
   }
    return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color juliaKonvergenz(Complex Z0){//Konvergenzgeschwindigkeit
   
    color rueckgabe = color(0);
    int n = 0;
    zAlt = Z0;
    while(n < maxiterations  ){
    zNeu = JuliaIteration(zAlt); 
    abstand = (zNeu.subtractC(Z0)).getLength();
    if(abstand > 10000000){      
         break;
      }
      zAlt = zNeu;
      n++;
    }    
    if(n != maxiterations) rueckgabe = color(0);
    else{
      farbIndex = round((float)(10*abstand)) % 4096; //if(tN==8)println(farbIndex);
      rueckgabe = farben.farbenSpezialB4096[farbIndex]; 
    }
    return rueckgabe;
}
///////////////////////////////////////////////////////////////////
color juliaTrap(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    int n = 0;
    trapped = false;
    zAlt = Z0;
  
    //while-Schleife---------------------------------------------------------------------
    while(n < maxiterations  ){
    
      zNeu = JuliaIteration(zAlt); 
      abstand =(zNeu.subtractC(Z0)).getLength();
      laenge = zNeu.getLength();
   
      //9 Kreise als "Traps" verwenden
      if ((R-r<laenge && laenge <R+r && n >0) || laenge < rM){ //n > 0, weil Abbildung = Id nicht erlaubt ist
         j=0; 
         double a=0;
         //8 Kreise
         while(j < 8){         
           a = MP[j].subtractC(zNeu).getLength();
           
           //trifft einen der 8 Kreise 
           if (a < r){
              trapped = true;
              int fWert = (int)(256*a);
              if (fWert > 127) fWert =127;
              if (fWert <0) fWert =0;
              n = j*128+fWert;    
           }      
           j++;
         }
         //Kreis im Urprung
         if(laenge<rM){
              trapped = true;
              int fWert = (int)(256*laenge);
              if (fWert > 127) fWert =127;
              if (fWert <0) fWert =0;
              n = j*128+fWert; 
         }
         //Je nachdem in welcher Falle gefangen wird die Farbe ausgewählt
         if(trapped == true) {
             farbIndex = n % 1152;
             farbe = farben.farben8Kreise1152[farbIndex];
             rueckgabe = farbe;
           break;      
         }
      }
      if(abstand > 100000){      
         break;
      }  
      if(selektor ==4){
        rueckgabe = color(0);//Fatougebiete schwarz
      }
       
      zAlt = zNeu; 
      n++;
    }
    if(trapped) rueckgabe = farbe;
    if(n != maxiterations && !trapped) rueckgabe = color(0);
    if(!trapped && selektor == 4) rueckgabe = color(0);
    if(n==maxiterations && !trapped && selektor !=4){
        farbIndex = round((float)(150*abstand)) % 4096; //if(tN==8)println(farbIndex);
        rueckgabe = farben.farbenSpezialB4096[farbIndex];    
      }   
 //end of while---------------------------------------------------------------------  
   return rueckgabe;
}
/////////////////////////////////////////////////////////////////////
color juliaQuadratTest(Complex Z0, double Dx, double Dy) {
    maxiterations = 100; //reicht...
    color rueckgabe ;
    
    int fpNummer0 =-1;//-1 steht für konvergent
    int n = 0;  
    zAlt = Z0;
    while (n < maxiterations) {
        zNeu = JuliaIteration(zAlt);   
        if(zNeu.getImaginaryPart()>360 || -zNeu.getImaginaryPart()>360 ){
          fpNummer0 = 1; //1 steht für divergent
          break;
        }
        zAlt = zNeu;
        n++;
    }      
  
    
//--------------------------------------------------    
    int fpNummer1 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < maxiterations) {
        zNeu = JuliaIteration(zAlt);   
        if(zNeu.getImaginaryPart()>360 || -zNeu.getImaginaryPart()>360){
          fpNummer1 = 1;
          break;
        }
        zAlt = zNeu;
        n++;
    }    
    
//---------------------------------------------------    
    int fpNummer2 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = JuliaIteration(zAlt);   
        if(zNeu.getImaginaryPart()>360 || -zNeu.getImaginaryPart()>360){
          fpNummer2 = 1;
          break;
        }
        zAlt = zNeu;        
        n++;
    }
   
//---------------------------------------------------------   
    int fpNummer3 =-1; 
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < maxiterations) {
        zNeu = JuliaIteration(zAlt);  
        if(zNeu.getImaginaryPart()>360 || -zNeu.getImaginaryPart()>360){
          fpNummer3 = 1;
          break;
        }
        zAlt = zNeu;      
        n++;
    }
//--------------------------------------------------------------------   
       
    if(fpNummer0==fpNummer1 && fpNummer1==fpNummer2 && fpNummer2==fpNummer3) rueckgabe = color(0);//alle gleich
      else rueckgabe = color(255);
    
    return rueckgabe;
}   

////////////////////////////////////////////////////////////////////////////////////
void bild1(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          if(tN==9)println("Zeile "+j);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y); //if(tN==8 && z0.getLength()>100)println(z0);
           
             pg.pixels[i+j*pg.width] = julia(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild2(){
 
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    colorMode(RGB);
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          if(tN==9)println("Zeile "+j);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = juliaKonvergenz(z0);
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////

void bild3(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
        if(tN==9)println("Zeile "+j);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             pg.pixels[i+j*pg.width] = juliaTrap(z0);    
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////
void bild4(){
  tN =this.gibNummer(); //println(tN);//Kontrolle, ob alle Thread starten
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  
          double x = xmin; if(tN ==9)println("Zeile "+j);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
             if(juliaQuadratTest(z0,dx,dy)==color(255)){
                pg.pixels[i+j*pg.width] = color(255);
                
              }else{
                 pg.pixels[i+j*pg.width] = color(0);//Nur Julia-Fraktal sichtbar
              }
           
            x += dx; 
          }
          y += dy;
        }             
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
}
////////////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////

Complex JuliaIteration(Complex zAlt){//Newton-Iteration ein mal     
     
        zNeu = f(zAlt,C).divide(g(zAlt));       
        zAlt = zNeu;//println(zAlt);     
 
  return zAlt;
 }
Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      zaehler = zAlt.power(8);//z^8
      zaehler = zaehler.addC(C);//z^8+c 
      zaehler = zaehler.subtractC((zAlt.power(3)).multiply(3));//z^8-3z^3+c 
      zaehler = zaehler.addC(zAlt.cosC());
      return zaehler;
 }
 Complex g(Complex zAlt){               //Nenner Newton-Iteration
     
      nenner = zAlt.power(6);//z^6
      nenner = nenner.addC(zAlt.sinC());
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }



}
